(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('bpmn-js/dist/bpmn-modeler.production.min.js')) :
  typeof define === 'function' && define.amd ? define('ngx-threeo-bpmn', ['exports', '@angular/core', '@angular/common/http', 'bpmn-js/dist/bpmn-modeler.production.min.js'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ngx-threeo-bpmn"] = {}, global.ng.core, global.ng.common.http, global.BpmnJS));
})(this, (function (exports, core, http, BpmnJS) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var BpmnJS__default = /*#__PURE__*/_interopDefaultLegacy(BpmnJS);

  var NgxThreeoBpmnComponent = /** @class */ (function () {
      function NgxThreeoBpmnComponent(http) {
          var _this = this;
          this.http = http;
          this.importDone = new core.EventEmitter();
          this.createEnded = new core.EventEmitter();
          this.connectionAdded = new core.EventEmitter();
          this.connectionRemoved = new core.EventEmitter();
          this.shapeRemoved = new core.EventEmitter();
          this.bpmnJS = new BpmnJS__default["default"]();
          this.bpmnJS.on('import.done', function (_a) {
              var error = _a.error;
              if (!error) {
                  _this.bpmnJS.get('canvas').zoom('fit-viewport');
              }
          });
          this.bpmnJS.on('create.ended', function (obj) {
              _this.createEnded.emit(obj);
          });
          this.bpmnJS.on('connection.added', function (obj) {
              _this.connectionAdded.emit(obj);
          });
          this.bpmnJS.on('connection.removed', function (obj) {
              _this.connectionRemoved.emit(obj);
          });
          this.bpmnJS.on('shape.removed', function (obj) {
              _this.shapeRemoved.emit(obj);
          });
      }
      NgxThreeoBpmnComponent.prototype.ngAfterContentInit = function () {
          this.bpmnJS.attachTo(this.el.nativeElement);
      };
      NgxThreeoBpmnComponent.prototype.ngOnChanges = function (changes) {
          // re-import whenever the url changes
          if (changes['xml']) {
              this.importDiagram(changes['xml'].currentValue);
          }
      };
      NgxThreeoBpmnComponent.prototype.ngOnDestroy = function () {
          this.bpmnJS.destroy();
      };
      /**
       * Creates a Promise to import the given XML into the current
       * BpmnJS instance, then returns it as an Observable.
       *
       * @see https://github.com/bpmn-io/bpmn-js-callbacks-to-promises#importxml
       */
      NgxThreeoBpmnComponent.prototype.importDiagram = function (xml) {
          if (!xml)
              return;
          this.bpmnJS.importXML(xml);
      };
      return NgxThreeoBpmnComponent;
  }());
  NgxThreeoBpmnComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'ngx-threeo-bpmn',
                  template: "<div #ref class=\"diagram-container\"></div>",
                  styles: ["\n    .diagram-container {\n      height: 100%;\n      width: 100%;\n    }\n  "]
              },] }
  ];
  NgxThreeoBpmnComponent.ctorParameters = function () { return [
      { type: http.HttpClient }
  ]; };
  NgxThreeoBpmnComponent.propDecorators = {
      el: [{ type: core.ViewChild, args: ['ref', { static: true },] }],
      importDone: [{ type: core.Output }],
      createEnded: [{ type: core.Output }],
      connectionAdded: [{ type: core.Output }],
      connectionRemoved: [{ type: core.Output }],
      shapeRemoved: [{ type: core.Output }],
      xml: [{ type: core.Input }]
  };

  var NgxThreeoBpmnModule = /** @class */ (function () {
      function NgxThreeoBpmnModule() {
      }
      return NgxThreeoBpmnModule;
  }());
  NgxThreeoBpmnModule.decorators = [
      { type: core.NgModule, args: [{
                  declarations: [NgxThreeoBpmnComponent],
                  imports: [],
                  exports: [NgxThreeoBpmnComponent]
              },] }
  ];

  /*
   * Public API Surface of ngx-threeo-bpmn
   */

  /**
   * Generated bundle index. Do not edit.
   */

  exports.NgxThreeoBpmnComponent = NgxThreeoBpmnComponent;
  exports.NgxThreeoBpmnModule = NgxThreeoBpmnModule;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-threeo-bpmn.umd.js.map
